var VueApiClient = (function (exports, es6_array_iterator, es6_promise, es6_object_assign, es7_promise_finally, es6_function_name, web_dom_iterable, getOwnPropertyDescriptor, getOwnPropertySymbols, keys, defineProperty, runtime, promise, stringify, axios, jsonata, parseDuration, assign) {
  'use strict';

  getOwnPropertyDescriptor = getOwnPropertyDescriptor && getOwnPropertyDescriptor.hasOwnProperty('default') ? getOwnPropertyDescriptor['default'] : getOwnPropertyDescriptor;
  getOwnPropertySymbols = getOwnPropertySymbols && getOwnPropertySymbols.hasOwnProperty('default') ? getOwnPropertySymbols['default'] : getOwnPropertySymbols;
  keys = keys && keys.hasOwnProperty('default') ? keys['default'] : keys;
  defineProperty = defineProperty && defineProperty.hasOwnProperty('default') ? defineProperty['default'] : defineProperty;
  promise = promise && promise.hasOwnProperty('default') ? promise['default'] : promise;
  stringify = stringify && stringify.hasOwnProperty('default') ? stringify['default'] : stringify;
  axios = axios && axios.hasOwnProperty('default') ? axios['default'] : axios;
  jsonata = jsonata && jsonata.hasOwnProperty('default') ? jsonata['default'] : jsonata;
  parseDuration = parseDuration && parseDuration.hasOwnProperty('default') ? parseDuration['default'] : parseDuration;
  assign = assign && assign.hasOwnProperty('default') ? assign['default'] : assign;

  var getOwnPropertyDescriptor$1 = getOwnPropertyDescriptor;

  var getOwnPropertySymbols$1 = getOwnPropertySymbols;

  var keys$1 = keys;

  var defineProperty$1 = defineProperty;

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      defineProperty$1(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      var ownKeys = keys$1(source);

      if (typeof getOwnPropertySymbols$1 === 'function') {
        ownKeys = ownKeys.concat(getOwnPropertySymbols$1(source).filter(function (sym) {
          return getOwnPropertyDescriptor$1(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  var promise$1 = promise;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      promise$1.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new promise$1(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  var stringify$1 = stringify;

  var assign$1 = assign;

  var config = {
    default: {}
  };
  function getConfig() {
    var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'default';
    return config[name];
  }
  function setConfig() {
    var key = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'default';
    var newConfig = arguments.length > 1 ? arguments[1] : undefined;
    if (!newConfig) return;
    if (!config[key]) config[key] = {};
    config[key].baseURL = newConfig.baseURL || '/';
    config[key].method = newConfig.method || 'GET';
    config[key].headers = assign$1({
      'X-Requested-With': 'XMLHttpRequest'
    }, newConfig.headers);
  }

  var cache = {};

  var script = {
    props: {
      value: [Object, Array, String],
      name: String,
      url: String,
      data: Object,
      params: Object,
      method: {
        type: String,
        default: 'get'
      },
      filter: String,
      successMutation: String,
      errorMutation: String,
      eager: Boolean,
      cache: [Boolean, String]
    },
    data: function data() {
      return {
        response: null
      };
    },
    mounted: function mounted() {
      if (this.shouldRequestOnMount) {
        if (this.cacheHit) {
          this.response = this.cacheHit;
          this.$emit('input', this.response);
          this.$emit('success', this.response);
        } else {
          console.log('no cache, doing action!');
          this.doAction();
        }
      }
    },
    computed: {
      shouldRequestOnMount: function shouldRequestOnMount() {
        // If the user hasn't put anything in the slot, just do the action
        // immediately; or if they have explicity set eager mode.
        return this.eager || !this.$slots.default && !this.$scopedSlots.default;
      },
      cacheDuration: function cacheDuration() {
        var duration = '1m';

        if (typeof this.cache === 'string') {
          duration = this.cache;
        }

        try {
          duration = parseDuration(duration);
        } catch (error) {
          duration = 300000;
        }

        console.log(duration);
        return duration;
      },
      cacheHit: function cacheHit() {
        // if cache is enabled, and key is less than 5m old, then return cached copy
        console.log(this.cache, cache);

        var cacheKey = this.url + stringify$1(this.params);

        console.log(cacheKey);
        var cacheItem = cache[cacheKey];
        console.log(cacheItem);
        console.log(this.type);

        if ( // Only cache GET requests
        (!this.type || this.type === 'get') && // Only if the prop is set
        this.cache // And only if there is an item in the cache
        && cacheItem // And that item is fresh enough
        && +new Date() - cacheItem.time < this.cacheDuration) {
          return cacheItem.data;
        }

        return false;
      }
    },
    methods: {
      doAction: function () {
        var _doAction = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee() {
          var axiosConfig, res, cacheKey;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return this.$nextTick();

                case 2:
                  axiosConfig = _objectSpread({}, getConfig(this.name));
                  if (this.method) axiosConfig.method = this.method;
                  if (this.params) axiosConfig.params = this.params;
                  if (this.data) axiosConfig.data = this.data;
                  if (this.url) axiosConfig.url = this.url;
                  console.log('emitting START!');
                  this.$emit('start');
                  _context.prev = 9;
                  _context.next = 12;
                  return axios.request(axiosConfig);

                case 12:
                  res = _context.sent;
                  // For successful calls, just return the data
                  this.response = res.data; // User has specified a JSONata filter

                  if (this.filter) {
                    this.response = jsonata(this.filter).evaluate(this.response);
                  } // User has specified a vuex mutation


                  if (this.successMutation && this.$store) {
                    this.$store.commit(this.successMutation, this.response);
                  }

                  if (this.cache) {
                    cacheKey = this.url + stringify$1(this.params);
                    cache[cacheKey] = {
                      time: +new Date(),
                      data: this.response
                    };
                  }

                  this.$emit('input', this.response);
                  this.$emit('success', this.response);
                  this.$emit("success:".concat(res.status), this.response);
                  _context.next = 28;
                  break;

                case 22:
                  _context.prev = 22;
                  _context.t0 = _context["catch"](9);
                  // For errors, return the whole response object for handling
                  this.response = _context.t0.response; // User has specified a vuex mutation

                  if (this.errorMutation && this.$store) {
                    this.$store.commit(this.errorMutation, this.response);
                  }

                  this.$emit('error', this.response);
                  this.$emit("error:".concat(_context.t0.response.status), this.response);

                case 28:
                  _context.prev = 28;
                  this.$emit('end');
                  return _context.finish(28);

                case 31:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this, [[9, 22, 28, 31]]);
        }));

        function doAction() {
          return _doAction.apply(this, arguments);
        }

        return doAction;
      }()
    }
  };

  function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
  /* server only */
  , shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
      createInjectorSSR = createInjector;
      createInjector = shadowMode;
      shadowMode = false;
    } // Vue.extend constructor export interop.


    var options = typeof script === 'function' ? script.options : script; // render functions

    if (template && template.render) {
      options.render = template.render;
      options.staticRenderFns = template.staticRenderFns;
      options._compiled = true; // functional template

      if (isFunctionalTemplate) {
        options.functional = true;
      }
    } // scopedId


    if (scopeId) {
      options._scopeId = scopeId;
    }

    var hook;

    if (moduleIdentifier) {
      // server build
      hook = function hook(context) {
        // 2.3 injection
        context = context || // cached call
        this.$vnode && this.$vnode.ssrContext || // stateful
        this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext; // functional
        // 2.2 with runInNewContext: true

        if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
          context = __VUE_SSR_CONTEXT__;
        } // inject component styles


        if (style) {
          style.call(this, createInjectorSSR(context));
        } // register component module identifier for async chunk inference


        if (context && context._registeredComponents) {
          context._registeredComponents.add(moduleIdentifier);
        }
      }; // used by ssr in case component is cached and beforeCreate
      // never gets called


      options._ssrRegister = hook;
    } else if (style) {
      hook = shadowMode ? function () {
        style.call(this, createInjectorShadow(this.$root.$options.shadowRoot));
      } : function (context) {
        style.call(this, createInjector(context));
      };
    }

    if (hook) {
      if (options.functional) {
        // register for functional component in vue file
        var originalRender = options.render;

        options.render = function renderWithStyleInjection(h, context) {
          hook.call(context);
          return originalRender(h, context);
        };
      } else {
        // inject component registration as beforeCreate hook
        var existing = options.beforeCreate;
        options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
      }
    }

    return script;
  }

  var normalizeComponent_1 = normalizeComponent;

  /* script */
  const __vue_script__ = script;
  // For security concerns, we use only base name in production mode. See https://github.com/vuejs/rollup-plugin-vue/issues/258
  script.__file = "/Users/john/Code/vue-api-client/src/components/ApiClient.vue";

  /* template */
  var __vue_render__ = function() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c(
      "span",
      {
        directives: [
          {
            name: "show",
            rawName: "v-show",
            value: _vm.$scopedSlots.default || _vm.$slots.default,
            expression: "$scopedSlots.default || $slots.default"
          }
        ],
        staticStyle: { display: "inline-block" }
      },
      [_vm._t("default", null, { action: _vm.doAction, response: _vm.response })],
      2
    )
  };
  var __vue_staticRenderFns__ = [];
  __vue_render__._withStripped = true;

    /* style */
    const __vue_inject_styles__ = undefined;
    /* scoped */
    const __vue_scope_id__ = undefined;
    /* module identifier */
    const __vue_module_identifier__ = undefined;
    /* functional template */
    const __vue_is_functional_template__ = false;
    /* style inject */
    
    /* style inject SSR */
    

    
    var ApiClient = normalizeComponent_1(
      { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
      __vue_inject_styles__,
      __vue_script__,
      __vue_scope_id__,
      __vue_is_functional_template__,
      __vue_module_identifier__,
      undefined,
      undefined
    );

  var script$1 = {
    props: ['name', 'headers', 'baseUrl'],
    created: function created() {
      setConfig(this.name, {
        headers: this.headers,
        baseURL: this.baseUrl
      });
    }
  };

  /* script */
  const __vue_script__$1 = script$1;
  // For security concerns, we use only base name in production mode. See https://github.com/vuejs/rollup-plugin-vue/issues/258
  script$1.__file = "/Users/john/Code/vue-api-client/src/components/ApiConfig.vue";

  /* template */
  var __vue_render__$1 = function() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c("span", { style: { display: "none" } })
  };
  var __vue_staticRenderFns__$1 = [];
  __vue_render__$1._withStripped = true;

    /* style */
    const __vue_inject_styles__$1 = undefined;
    /* scoped */
    const __vue_scope_id__$1 = undefined;
    /* module identifier */
    const __vue_module_identifier__$1 = undefined;
    /* functional template */
    const __vue_is_functional_template__$1 = false;
    /* style inject */
    
    /* style inject SSR */
    

    
    var ApiConfig = normalizeComponent_1(
      { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
      __vue_inject_styles__$1,
      __vue_script__$1,
      __vue_scope_id__$1,
      __vue_is_functional_template__$1,
      __vue_module_identifier__$1,
      undefined,
      undefined
    );

  var plugin = {
    install: function install(Vue) {
      Vue.component('ApiClient', ApiClient);
      Vue.component('ApiConfig', ApiConfig);
    }
  };

  exports.default = plugin;

  return exports;

}({}, null, null, null, null, null, null, getOwnPropertyDescriptor, getOwnPropertySymbols, keys, defineProperty, null, promise, stringify, axios, jsonata, parseDuration, assign));
